Screen _NewImage(640, 640, 32)

Type Tile
    As _Byte Omit 'BULDRA in bits
    As _Byte STATE
End Type

Const TILE_STATE_BLANK = 1, TILE_STATE_UP = 2, TILE_STATE_LEFT = 3, TILE_STATE_DOWN = 4, TILE_STATE_RIGHT = 5, TILE_STATE_ALL = 6

Dim As Tile Tile_Empty, Tiles(1 To 128, 1 To 128), Tile_Up, Tile_Down, Tile_Left, Tile_Right

Dim As Long TileImages(0 To 6): For I = 0 To 6: TileImages(I) = LoadImage(I): Next I

'Place a random tile at center'
Randomize Timer: RandomTile Tiles(32 + CInt(Rnd * 64), 32 + CInt(Rnd * 64))

'Start the loop
S = 1
Do
    Cls
    '_Limit 16
    If S = 0 Or Stuck Then
        If S = 0 Then _Title "Finished" Else _Title "Stuck"
        Do
            _Limit 60
            If _KeyDown(32) Then Run
            If _KeyDown(27) Then System
        Loop
    Else
        S = 0
        For I = 1 To 128
            For J = 1 To 128
                If J > 1 Then Tile_Up = Tiles(I, J - 1) Else Tile_Up = Tile_Empty
                If J < 128 Then Tile_Down = Tiles(I, J + 1) Else Tile_Down = Tile_Empty
                If I < 128 Then Tile_Right = Tiles(I + 1, J) Else Tile_Right = Tile_Empty
                If I > 1 Then Tile_Left = Tiles(I - 1, J) Else Tile_Left = Tile_Empty
                UpdateTile Tiles(I, J), Tile_Up, Tile_Down, Tile_Left, Tile_Right
                If J > 1 Then Tiles(I, J - 1) = Tile_Up
                If J < 128 Then Tiles(I, J + 1) = Tile_Down
                If I < 128 Then Tiles(I + 1, J) = Tile_Right
                If I > 1 Then Tiles(I - 1, J) = Tile_Left
                If Tiles(I, J).STATE Then _Continue
                If TryTile(Tiles(I, J)) = 0 Then Stuck = -1
                S = S + 1
        Next J, I
    End If
    _Title "Working"
    For I = 1 To 128: For J = 1 To 128: _PutImage (I * 5 - 5, J * 5 - 5)-(I * 5 - 1, J * 5 - 1), TileImages(Tiles(I, J).STATE): Next J, I
    _Display
Loop
System
'--------------
Sub RandomTile (T As Tile)
    Dim __T As Tile
    T.STATE = 6
    UpdateTile T, __T, __T, __T, __T
End Sub
Sub UpdateTile (T As Tile, TU As Tile, TD As Tile, TL As Tile, TR As Tile)
    Select Case T.STATE
        Case TILE_STATE_BLANK
            TU.Omit = TU.Omit Or &B001111
            TD.Omit = TD.Omit Or &B011011
            TL.Omit = TL.Omit Or &B010111
            TR.Omit = TR.Omit Or &B011101
        Case TILE_STATE_UP
            TU.Omit = TU.Omit Or &B110000
            TD.Omit = TD.Omit Or &B011011
            TL.Omit = TL.Omit Or &B101000
            TR.Omit = TR.Omit Or &B100010
        Case TILE_STATE_DOWN
            TU.Omit = TU.Omit Or &B001111
            TD.Omit = TD.Omit Or &B100100
            TL.Omit = TL.Omit Or &B101000
            TR.Omit = TR.Omit Or &B100010
        Case TILE_STATE_LEFT
            TU.Omit = TU.Omit Or &B110000
            TD.Omit = TD.Omit Or &B100100
            TL.Omit = TL.Omit Or &B101000
            TR.Omit = TR.Omit Or &B011101
        Case TILE_STATE_RIGHT
            TU.Omit = TU.Omit Or &B110000
            TD.Omit = TD.Omit Or &B100100
            TL.Omit = TL.Omit Or &B010111
            TR.Omit = TR.Omit Or &B100010
        Case TILE_STATE_ALL
            TU.Omit = TU.Omit Or &B110000
            TD.Omit = TD.Omit Or &B100100
            TL.Omit = TL.Omit Or &B101000
            TR.Omit = TR.Omit Or &B100010
    End Select
End Sub
Function TryTile (T As Tile)
    Options$ = "BULDRA"
    SetOptions$ = ""
    If T.Omit And &B100000 Then Asc(Options$, 1) = 0
    If T.Omit And &B010000 Then Asc(Options$, 2) = 0
    If T.Omit And &B001000 Then Asc(Options$, 3) = 0
    If T.Omit And &B000100 Then Asc(Options$, 4) = 0
    If T.Omit And &B000010 Then Asc(Options$, 5) = 0
    If T.Omit And &B000001 Then Asc(Options$, 6) = 0
    For I = 1 To 6
        If Asc(Options$, I) > 0 Then SetOptions$ = SetOptions$ + Chr$(Asc(Options$, I))
    Next I
    If Len(SetOptions$) = 0 Then Exit Function
    If Len(SetOptions$) < 5 Then STATE = Asc(SetOptions$, Int(Rnd * Len(SetOptions$)) + 1)
    Select Case STATE
        Case 66: T.STATE = TILE_STATE_BLANK
        Case 85: T.STATE = TILE_STATE_UP
        Case 76: T.STATE = TILE_STATE_LEFT
        Case 68: T.STATE = TILE_STATE_DOWN
        Case 82: T.STATE = TILE_STATE_RIGHT
        Case 65: T.STATE = TILE_STATE_ALL
    End Select
    TryTile = -1
End Function
Function LoadImage& (I)
    LoadImage& = _LoadImage("WFC\" + _Trim$(Mid$("EmptyBlankUp   Left Down RightAll  ", I * 5 + 1, 5)) + ".png", 32)
End Function
